Dynamic data update in EJ2 JavaScript Chart control

13 Jun 202420 minutes to read

Adding a new data point

The addPoint method is used to dynamically add a new data point to the chart series. This method is particularly useful when you want to update the chart with a new data point without having to refresh the entire chart. This method takes two parameters:

  • The first parameter is the new data point to add to your existing data source.
  • The optional second parameter specifies the animation duration for adding the new data point.
var addData = [
  { x: "Germany", y: 72 },
  { x: "Russia", y: 103.1 },
  { x: "Brazil", y: 139.1 },
  { x: "India", y: 462.1 },
  { x: "China", y: 721.4 },
  { x: "USA", y: 286.9 },
  { x: "Great Britain", y: 115.1 },
  { x: "Nigeria", y: 97.2 }
];

var chart = new ej.charts.Chart({
  primaryXAxis: {
    valueType: 'Category', enableTrim: false, majorTickLines: { width: 0 }, majorGridLines: { width: 0 }
  },
  chartArea: { border: { width: 1 } },
  primaryYAxis:
  {
    minimum: 0, maximum: 800, labelFormat: '{value}M', edgeLabelPlacement: 'Shift'
  },
  series: [
    {
      dataSource: addData, xName: 'x', yName: 'y', type: 'Spline', width: 2, name: 'Users',
      marker: { visible: true, dataLabel: { visible: true, position: 'Top', font: { fontWeight: '600' } } }
    }
  ],
  title: 'Internet Users - 2016',
  legendSettings: {
    visible: false
  }
}, '#element');

document.getElementById('add').onclick = function () {
  chart.series[0].addPoint({ x: 'Japan', y: 118.2 });
}
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Animation</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    
<script src="https://cdn.syncfusion.com/ej2/32.1.19/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
        <button id="add">Add Point</button>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Removing an existing data point

The removePoint method is used to dynamically remove a data point from the chart series. This method is particularly useful when you want to update the chart by removing an existing data point without having to refresh the entire chart. This method takes two parameters:

  • The first parameter is the index of the data point that needs to be removed from the existing data source.
  • The optional second parameter specifies the animation duration for removing the data point.
var addData = [
  { x: "Germany", y: 72 },
  { x: "Russia", y: 103.1 },
  { x: "Brazil", y: 139.1 },
  { x: "India", y: 462.1 },
  { x: "China", y: 721.4 },
  { x: "USA", y: 286.9 },
  { x: "Great Britain", y: 115.1 },
  { x: "Nigeria", y: 97.2 }
];

var chart = new ej.charts.Chart({
  primaryXAxis: {
    valueType: 'Category', enableTrim: false, majorTickLines: { width: 0 }, majorGridLines: { width: 0 }
  },
  chartArea: { border: { width: 1 } },
  primaryYAxis:
  {
    minimum: 0, maximum: 800, labelFormat: '{value}M', edgeLabelPlacement: 'Shift'
  },
  series: [
    {
      dataSource: addData, xName: 'x', yName: 'y', type: 'Spline', width: 2, name: 'Users',
      marker: { visible: true, dataLabel: { visible: true, position: 'Top', font: { fontWeight: '600' } } }
    }
  ],
  title: 'Internet Users - 2016',
  legendSettings: {
    visible: false
  }
}, '#element');

document.getElementById('remove').onclick = function () {
  chart.series[0].removePoint(0);
}
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Animation</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    
<script src="https://cdn.syncfusion.com/ej2/32.1.19/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
        <button id="remove">Remove Point</button>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Replacing entire data points

To replace the existing data source in the chart with a new data source, you can simply use the setData method. This method allows you to replace the existing data points in the chart series with a new set of data points, enabling you to easily update the chart with new information. This method takes two parameters:

  • The first parameter is the new set of data points to be updated.
  • The optional second parameter specifies the animation duration for updating the new data source.
var updatedData = [
  { x: 'Jewellery', y: 75 },
  { x: 'Shoes', y: 45 },
  { x: 'Footwear', y: 73 },
  { x: 'Pet Services', y: 53 },
  { x: 'Business Clothing', y: 85 },
  { x: 'Office Supplies', y: 68 },
  { x: 'Food', y: 45 }
];

var chart = new ej.charts.Chart({
  primaryXAxis: {
    valueType: 'Category', majorGridLines: { width: 0 }, labelStyle: { size: '12px' }, labelIntersectAction: 'Rotate90'
  },
  chartArea: { border: { width: 0 } },
  primaryYAxis:
  {
    title: 'Sales (in percentage)', labelFormat: '{value}%', lineStyle: { width: 0 }, majorTickLines: { width: 0 }, interval: 5, minimum: 0, maximum: 100
  },
  series: [
    {
      dataSource: updatedData, xName: 'x', yName: 'y', type: 'Column',
      cornerRadius: { topLeft: 15, topRight: 15 }, columnWidth: 0.5
    }
  ],
  title: 'Sales by product',
  axisRangeCalculated: function (args) {
    if (args.axis.name === 'primaryYAxis') {
      args.maximum = args.maximum > 100 ? 100 : args.maximum;
      if (args.maximum > 80) {
        args.interval = 20;
      }
      else if (args.maximum > 40) {
        args.interval = 10;
      }
    }
  }
}, '#element');

function getRandomInt(min, max) {
  return Math.floor(Math.random() * (max - min + 1)) + min;
}
document.getElementById('update').onclick = () => {
  var newData = updatedData.map(function (item) {
    var value = getRandomInt(10, 90);
    return { x: item.x, y: value };
  });
  if (chart.series.length > 0) {
    chart.series[0].setData(newData, 500);
  }
}
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Animation</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    
<script src="https://cdn.syncfusion.com/ej2/32.1.19/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id='element'></div>
        <button id='update'>Update Data</button>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Click to add or remove a data point

You can use mouse or touch events to dynamically add or remove data points from an existing data source by clicking on the appropriate position within the chart area. To add a new data point to the existing data source, click anywhere in the chart area, retrieve the x-axis and y-axis information of the clicked location from the chartMouseClick event arguments. Then, utilize the addPoint method to add a new data point to the existing data source.

To remove a data point from the existing data source, simply click on the desired data point. To achieve this, first, verify whether the clicked data point obtained from chartMouseClick already exists in the data source. If it does, remove it by utilizing the removePoint method based on its index.

var chartData = [
  { x: 20, y: 20 }, { x: 80, y: 80 }
];
var chart = new ej.charts.Chart({
  primaryXAxis: {
    edgeLabelPlacement: 'Shift', rangePadding: 'Additional', majorGridLines: { width: 0 }
  },
  chartArea: { border: { width: 0 } },
  primaryYAxis:
  {
    title: 'Value', interval: 20, lineStyle: { width: 0 }, majorTickLines: { width: 0 }
  },
  series: [
    {
      dataSource: chartData, xName: 'x', yName: 'y', type: 'Line', width: 3,
      marker: { visible: true, isFilled: true, border: { width: 2, color: 'White' }, width: 13, height: 13 }
    }
  ],
  title: 'User supplied data',
  tooltip: { enable: true },
  chartMouseClick: function (args) {
    var isRemoved = false;
    if (args.axisData) {
      for (var i = 0; i < chart.series[0].points.length; i++) {
        var markerWidth = chart.series[0].marker.width / 2;
        var roundedX = Math.round(args.axisData.primaryXAxis) + markerWidth;
        var roundedY = Math.round(args.axisData.primaryYAxis) + markerWidth;
        var pointX = Math.round(chart.series[0].points[i].x) + markerWidth;
        var pointY = Math.round(chart.series[0].points[i].y) + markerWidth;
        if ((roundedX === pointX || roundedX + 1 === pointX || roundedX - 1 === pointX) &&
          (roundedY === pointY || roundedY + 1 === pointY || roundedY - 1 === pointY)) {
          if (chart.series[0].points.length > 1) {
            var points = chart.series[0].points;
            var duration = i === 0 || i === points[points.length - 1].index ? 500 : 0;
            chart.series[0].removePoint(i, duration);
          }
          isRemoved = true;
        }
      }
      if (!isRemoved) {
        chart.series[0].addPoint({ x: Math.round(args.axisData.primaryXAxis), y: Math.round(args.axisData.primaryYAxis) });
      }
    }
  },
  axisRangeCalculated: function (args) {
    if (args.axis.name === 'primaryXAxis') {
      if (args.interval < 10) {
        args.maximum = args.maximum + 10;
        args.minimum = args.minimum - 10;
        args.interval = 10;
      }
    }
    if (args.axis.name === 'primaryYAxis') {
      if (args.maximum <= 60) {
        args.interval = 10;
      }
    }
  }
}, '#addPoint');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Animation</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    
<script src="https://cdn.syncfusion.com/ej2/32.1.19/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="addPoint"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Dynamic data update in Angular Chart component

11 Oct 202524 minutes to read

Adding a new data point

The addPoint method is used to dynamically add a new data point to the chart series. This method is particularly useful when you want to update the chart with a new data point without having to refresh the entire chart. This method takes two parameters:

  • The first parameter is the new data point to add to your existing data source.
  • The optional second parameter specifies the animation duration for adding the new data point.
import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { ChartModule } from '@syncfusion/ej2-angular-charts';
import { ChartComponent, SplineSeriesService, CategoryService, LegendService, DataLabelService } from '@syncfusion/ej2-angular-charts';
import { ButtonModule } from '@syncfusion/ej2-angular-buttons';
import { Component, OnInit, ViewChild  } from '@angular/core';

@Component({
imports: [
         ChartModule, ButtonModule
    ],

providers: [ SplineSeriesService, CategoryService, LegendService, DataLabelService ],
standalone: true,
    selector: 'app-container',
    template: `<ejs-chart #chart id="chart-container" [primaryXAxis]='primaryXAxis'[primaryYAxis]='primaryYAxis' [title]='title' [legendSettings]='legendSettings' [chartArea]='chartArea'>
        <e-series-collection>
            <e-series [dataSource]='chartData' type='Spline' xName='x' yName='y' name='Users' width=2 [marker]='marker'></e-series>
        </e-series-collection>
    </ejs-chart>
    <button ej-button id='add' (click)='click()'>Add Point</button>`
})
export class AppComponent implements OnInit {
    @ViewChild('chart')
    public chart?: ChartComponent;
    public primaryXAxis?: Object;
    public primaryYAxis?: Object;
    public chartData?: Object[] = [
        { x: "Germany", y: 72 },
        { x: "Russia", y: 103.1 },
        { x: "Brazil", y: 139.1 },
        { x: "India", y: 462.1 },
        { x: "China", y: 721.4 },
        { x: "USA", y: 286.9 },
        { x: "Great Britain", y: 115.1 },
        { x: "Nigeria", y: 97.2 }
    ];
    public title?: string;
    public marker?: Object;
    public legendSettings?: Object;
    public chartArea?: Object;
    ngOnInit(): void {
        this.primaryXAxis = {
            valueType: 'Category', 
            enableTrim: false, 
            majorTickLines: { width: 0 }, 
            majorGridLines: { width: 0 }
        };
        this.primaryYAxis = {
            minimum: 0, 
            maximum: 800, 
            labelFormat: '{value}M', 
            edgeLabelPlacement: 'Shift'
        };
        this.title = 'Internet Users - 2016';
        this.marker = { 
            visible: true, 
            dataLabel: { 
                visible: true, 
                position: 'Top', 
                font: { fontWeight: '600' } 
            } 
        };
        this.legendSettings = { visible: false };
        this.chartArea = {
            border: { width: 1 }
        };
    }
    click() {
        if (this.chart?.series?.length) {
            if (typeof this.chart.series[0].addPoint === 'function') {
            this.chart?.series[0].addPoint({ x: 'Japan', y: 118.2 });
            }
        } 
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Removing an existing data point

The removePoint method is used to dynamically remove a data point from the chart series. This method is particularly useful when you want to update the chart by removing an existing data point without having to refresh the entire chart. This method takes two parameters:

  • The first parameter is the index of the data point that needs to be removed from the existing data source.
  • The optional second parameter specifies the animation duration for removing the data point.
import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { ChartModule } from '@syncfusion/ej2-angular-charts';
import { ChartComponent, SplineSeriesService, CategoryService, LegendService, DataLabelService } from '@syncfusion/ej2-angular-charts';
import { ButtonModule } from '@syncfusion/ej2-angular-buttons';
import { Component, OnInit, ViewChild  } from '@angular/core';

@Component({
imports: [
         ChartModule, ButtonModule
    ],

providers: [ SplineSeriesService, CategoryService, LegendService, DataLabelService ],
standalone: true,
    selector: 'app-container',
    template: `<ejs-chart #chart id="chart-container" [primaryXAxis]='primaryXAxis'[primaryYAxis]='primaryYAxis' [title]='title' [legendSettings]='legendSettings' [chartArea]='chartArea'>
        <e-series-collection>
            <e-series [dataSource]='chartData' type='Spline' xName='x' yName='y' name='Users' width=2 [marker]='marker'></e-series>
        </e-series-collection>
    </ejs-chart>
    <button ej-button id='remove' (click)='click()'>Remove Point</button>`
})
export class AppComponent implements OnInit {
    @ViewChild('chart')
    public chart?: ChartComponent;
    public primaryXAxis?: Object;
    public primaryYAxis?: Object;
    public chartData?: Object[] = [
        { x: "Germany", y: 72 },
        { x: "Russia", y: 103.1 },
        { x: "Brazil", y: 139.1 },
        { x: "India", y: 462.1 },
        { x: "China", y: 721.4 },
        { x: "USA", y: 286.9 },
        { x: "Great Britain", y: 115.1 },
        { x: "Nigeria", y: 97.2 }
    ];
    public title?: string;
    public marker?: Object;
    public legendSettings?: Object;
    public chartArea?: Object;
    ngOnInit(): void {
        this.primaryXAxis = {
            valueType: 'Category', 
            enableTrim: false, 
            majorTickLines: { width: 0 }, 
            majorGridLines: { width: 0 }
        };
        this.primaryYAxis = {
            minimum: 0, 
            maximum: 800, 
            labelFormat: '{value}M', 
            edgeLabelPlacement: 'Shift'
        };
        this.title = 'Internet Users - 2016';
        this.marker = { 
            visible: true, 
            dataLabel: { 
                visible: true, 
                position: 'Top', 
                font: { fontWeight: '600' } 
            } 
        };
        this.legendSettings = { visible: false };
        this.chartArea = {
            border: { width: 1 }
        };
    }
    click() {
        if (this.chart?.series?.length) {
            if (typeof this.chart.series[0].removePoint === 'function') {
        this.chart?.series[0].removePoint(0);
            }
        }
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Replacing entire data points

To replace the existing data source in the chart with a new data source, you can simply use the setData method. This method allows you to replace the existing data points in the chart series with a new set of data points, enabling you to easily update the chart with new information. This method takes two parameters:

  • The first parameter is the new set of data points to be updated.
  • The optional second parameter specifies the animation duration for updating the new data source.
import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { ChartModule } from '@syncfusion/ej2-angular-charts';
import { ChartComponent, ColumnSeriesService, CategoryService, IAxisRangeCalculatedEventArgs } from '@syncfusion/ej2-angular-charts';
import { ButtonModule } from '@syncfusion/ej2-angular-buttons';
import { Component, OnInit, ViewChild  } from '@angular/core';

@Component({
imports: [
         ChartModule, ButtonModule
    ],

providers: [ ColumnSeriesService, CategoryService ],
standalone: true,
    selector: 'app-container',
    template: `<ejs-chart #chart id="chart-container" [primaryXAxis]='primaryXAxis'[primaryYAxis]='primaryYAxis' [title]='title' [chartArea]='chartArea' (axisRangeCalculated)="axisRangeCalculated($event)">
        <e-series-collection>
            <e-series [dataSource]='chartData' type='Column' xName='x' yName='y' columnWidth=0.5 [cornerRadius]='cornerRadius'></e-series>
        </e-series-collection>
    </ejs-chart>
    <button ej-button id='update' (click)='click()'>Update Data</button>`
})
export class AppComponent implements OnInit {
    @ViewChild('chart')
    public chart?: ChartComponent;
    public primaryXAxis?: Object;
    public primaryYAxis?: Object;
    public chartData?: Object[] = [
        { x: 'Jewellery', y: 75 },
        { x: 'Shoes', y: 45 },
        { x: 'Footwear', y: 73 },
        { x: 'Pet Services', y: 53 },
        { x: 'Business Clothing', y: 85 },
        { x: 'Office Supplies', y: 68 },
        { x: 'Food', y: 45 }
    ];
    public title?: string;
    public cornerRadius?: Object;
    public chartArea?: Object;
    public getRandomInt(min: number, max: number) {
        return Math.floor(Math.random() * (max - min + 1)) + min;
    }
    ngOnInit(): void {
        this.primaryXAxis = {
            valueType: 'Category', 
            majorGridLines: { width: 0 }, 
            labelStyle: { size: '12px' }, 
            labelIntersectAction: 'Rotate90'
        };
        this.primaryYAxis = {
            title: 'Sales (in percentage)', 
            labelFormat: '{value}%', 
            lineStyle: { width: 0 }, 
            majorTickLines: { width: 0 }, 
            interval: 5, 
            minimum: 0, 
            maximum: 100
        };
        this.title = 'Sales by product';
        this.cornerRadius = { topLeft: 15, topRight: 15 };
        this.chartArea = {
            border: { width: 0 }
        };
    }
    click() {
        if (this.chart && this.chart.series && this.chart.series.length > 0 && this.chart.series[0].dataSource) {
            const newData = (
                this.chart.series[0].dataSource as { x: string; y: number }[]
            ).map((item) => {
                const value: number = this.getRandomInt(10, 90);
                return { x: item.x, y: value };
            });
            if (typeof this.chart.series[0].setData === 'function') {
                this.chart.series[0].setData(newData, 500);
            }
        }
    }
    public axisRangeCalculated (args: IAxisRangeCalculatedEventArgs): void {
        if (args.axis.name === 'primaryYAxis') {
            args.maximum = args.maximum as number > 100 ? 100 : args.maximum;
            if (args.maximum > 80) {
                args.interval = 20;
            } else if(args.maximum > 40){
                args.interval = 10;
            }
        }
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Click to add or remove a data point

You can use mouse or touch events to dynamically add or remove data points from an existing data source by clicking on the appropriate position within the chart area. To add a new data point to the existing data source, click anywhere in the chart area, retrieve the x-axis and y-axis information of the clicked location from the chartMouseClick event arguments. Then, utilize the addPoint method to add a new data point to the existing data source.

To remove a data point from the existing data source, simply click on the desired data point. To achieve this, first, verify whether the clicked data point obtained from chartMouseClick already exists in the data source. If it does, remove it by utilizing the removePoint method based on its index.

import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { ChartModule } from '@syncfusion/ej2-angular-charts';
import { ChartComponent, LineSeriesService, CategoryService, TooltipService, DataLabelService, IAxisRangeCalculatedEventArgs, Series, IMouseEventArgs } from '@syncfusion/ej2-angular-charts';
import { Component, OnInit, ViewChild  } from '@angular/core';

@Component({
imports: [
         ChartModule
    ],

providers: [ LineSeriesService, CategoryService, TooltipService, DataLabelService ],
standalone: true,
    selector: 'app-container',
    template: `<ejs-chart #chart id="chart-container" [primaryXAxis]='primaryXAxis'[primaryYAxis]='primaryYAxis' [title]='title' [chartArea]='chartArea' [tooltip]='tooltip' (chartMouseClick)='chartMouseClick($event)' (axisRangeCalculated)="axisRangeCalculated($event)">
        <e-series-collection>
            <e-series [dataSource]='chartData' type='Line' xName='x' yName='y' width=3 [marker]='marker'></e-series>
        </e-series-collection>
    </ejs-chart>
   `
})
export class AppComponent implements OnInit {
    @ViewChild('chart')
    public chart?: ChartComponent;
    public primaryXAxis?: Object;
    public primaryYAxis?: Object;
    public chartData?: Object[] = [
        { x: 20, y: 20 }, 
        { x: 80, y: 80 }
    ];
    public title?: string;
    public marker?: Object;
    public chartArea?: Object;
    public tooltip?: Object;
    ngOnInit(): void {
        this.primaryXAxis = {
            edgeLabelPlacement: 'Shift', 
            rangePadding: 'Additional', 
            majorGridLines: { width: 0 }
        };
        this.primaryYAxis = {
            title: 'Value', 
            interval: 20, 
            lineStyle: { width: 0 }, 
            majorTickLines: { width: 0 }
        };
        this.title = 'User supplied data';
        this.marker = { 
            visible: true, 
            isFilled: true, 
            border: { 
                width: 2, 
                color: 'White' 
            }, 
            width: 13, 
            height: 13 
        };
        this.chartArea = {
            border: { width: 0 }
        };
        this.tooltip = { enable: true };
    }
    public chartMouseClick(args: IMouseEventArgs): void {
        let isRemoved: boolean = false;
        if (args.axisData && this.chart?.series) {
            for (let i: number = 0; i < (this.chart.series[0] as Series).points.length; i++) {
                let markerWidth: number = (this.chart.series[0] as Series).marker?.width ?? 0 / 2;
                let roundedX: number = Math.round(args.axisData['primaryXAxis']) + markerWidth;
                let roundedY: number = Math.round(args.axisData['primaryYAxis']) + markerWidth;
                let pointX: number = Math.round((this.chart.series[0] as Series).points[i].x as number) + markerWidth;
                let pointY: number = Math.round((this.chart.series[0] as Series).points[i].y as number) + markerWidth;
                if ((roundedX === pointX || roundedX + 1 === pointX || roundedX - 1 === pointX) &&
                    (roundedY === pointY || roundedY + 1 === pointY || roundedY - 1 === pointY)) {
                    if ((this.chart.series[0] as Series).points.length > 1) {
                        const points = (this.chart.series[0] as Series).points;
                        const duration: number = i === 0 || i === points[points.length - 1].index ? 500 : 0;
                        if (this.chart?.series?.length) {
                            if (typeof this.chart.series[0].removePoint === 'function') {
                                this.chart.series[0].removePoint(i, duration);
                            }
                        }
                    }
                    isRemoved = true;
                }
            }
            if (!isRemoved) {
                if (this.chart?.series?.length) {
                    if (typeof this.chart.series[0].addPoint === 'function') {
                        this.chart.series[0].addPoint({
                            x: Math.round(args.axisData['primaryXAxis']),
                            y: Math.round(args.axisData['primaryYAxis'])
                        });
                    }
                }
            }
        }
    };
    public axisRangeCalculated(args: IAxisRangeCalculatedEventArgs): void {
        if (args.axis.name === 'primaryXAxis') {
            if (args.interval < 10) {
                args.maximum = args.maximum + 10;
                args.minimum = args.minimum - 10;
                args.interval = 10;
            }
        }
        if (args.axis.name === 'primaryYAxis') {
            if (args.maximum <= 60) {
                args.interval = 10;
            }
        }
    };
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

See Also

Dynamic data update in Vue Chart component

26 Jun 202424 minutes to read

Adding a new data point

The addPoint method is used to dynamically add a new data point to the chart series. This method is particularly useful when you want to update the chart with a new data point without having to refresh the entire chart. This method takes two parameters:

  • The first parameter is the new data point to add to your existing data source.
  • The optional second parameter specifies the animation duration for adding the new data point.
<template>
  <div id="app">
    <ejs-chart ref="chart" id="container" :primaryXAxis='primaryXAxis' :primaryYAxis='primaryYAxis' :title='title' :legendSettings='legendSettings' :chartArea='chartArea'>
        <e-series-collection>
          <e-series :dataSource='seriesData' type='Spline' xName='x' yName='y' name='Users' width=2 :marker='marker'></e-series>
        </e-series-collection>
    </ejs-chart>
    <ejs-button id='add' @click.native='onClick'>Add Point</ejs-button>
  </div>
</template>
<script setup>
import { provide, ref } from "vue";
import { ChartComponent as EjsChart, SeriesCollectionDirective as ESeriesCollection, SeriesDirective as ESeries, SplineSeries, Category, DataLabel, Legend } from "@syncfusion/ej2-vue-charts";
import { ButtonComponent as EjsButton } from "@syncfusion/ej2-vue-buttons";

const chart = ref(null);
const seriesData = [
  { x: "Germany", y: 72 },
  { x: "Russia", y: 103.1 },
  { x: "Brazil", y: 139.1 },
  { x: "India", y: 462.1 },
  { x: "China", y: 721.4 },
  { x: "USA", y: 286.9 },
  { x: "Great Britain", y: 115.1 },
  { x: "Nigeria", y: 97.2 }
];
const primaryXAxis = {
  valueType: 'Category', 
  enableTrim: false, 
  majorTickLines: { width: 0 }, 
  majorGridLines: { width: 0 }
};
const primaryYAxis = {
  minimum: 0, 
  maximum: 800, 
  labelFormat: '{value}M', 
  edgeLabelPlacement: 'Shift'
};
const marker = {
  visible: true, 
  dataLabel: { 
    visible: true, 
    position: 'Top', 
    font: { 
      fontWeight: '600' 
    } 
  }
};
const title = 'Internet Users - 2016';
const legendSettings = {
  visible: false
};
const chartArea = {
  border: {
    width: 1
  }
};

provide('chart', [SplineSeries, Category, DataLabel, Legend]);

const onClick = function() {     
  this.$refs.chart.ej2Instances.series[0].addPoint({ x: 'Japan', y: 118.2 });
};

</script>
<style>
  #container {
    height: 350px;
  }
</style>
<template>
    <div id="app">
        <ejs-chart ref="chart" id="container" :primaryXAxis='primaryXAxis' :primaryYAxis='primaryYAxis' :title='title' :legendSettings='legendSettings' :chartArea='chartArea'>
          <e-series-collection>
            <e-series :dataSource='seriesData' type='Spline' xName='x' yName='y' name='Users' width=2 :marker='marker'></e-series>
          </e-series-collection>
        </ejs-chart>
        <ejs-button id='add' @click.native='onClick'>Add Point</ejs-button>
    </div>
</template>
<script>
import Vue from "vue";
import { ChartPlugin, SplineSeries, Category, DataLabel, Legend } from "@syncfusion/ej2-vue-charts";
import { ButtonPlugin } from "@syncfusion/ej2-vue-buttons";

Vue.use(ChartPlugin);
Vue.use(ButtonPlugin);

export default {
  data() {
    return {
        seriesData: [
          { x: "Germany", y: 72 },
          { x: "Russia", y: 103.1 },
          { x: "Brazil", y: 139.1 },
          { x: "India", y: 462.1 },
          { x: "China", y: 721.4 },
          { x: "USA", y: 286.9 },
          { x: "Great Britain", y: 115.1 },
          { x: "Nigeria", y: 97.2 }
        ],
        primaryXAxis: {
          valueType: 'Category', 
          enableTrim: false, 
          majorTickLines: { width: 0 }, 
          majorGridLines: { width: 0 }
        },
        primaryYAxis:
        {
          minimum: 0, 
          maximum: 800, 
          labelFormat: '{value}M', 
          edgeLabelPlacement: 'Shift'
        },
        marker: {
          visible: true, 
          dataLabel: { 
            visible: true, 
            position: 'Top', 
            font: { 
              fontWeight: '600' 
            } 
          }
        },
        title: 'Internet Users - 2016',
        legendSettings: {
          visible: false
        },
        chartArea: {
          border: {
            width: 1
          }
        }
    };
  },
  provide: {
    chart: [SplineSeries, Category, DataLabel, Legend]
  },
  methods: {
      onClick: function() {     
        this.$refs.chart.ej2Instances.series[0].addPoint({ x: 'Japan', y: 118.2 });
      }
  }
};
</script>
<style>
  #container {
    height: 350px;
  }
</style>

Removing an existing data point

The removePoint method is used to dynamically remove a data point from the chart series. This method is particularly useful when you want to update the chart by removing an existing data point without having to refresh the entire chart. This method takes two parameters:

  • The first parameter is the index of the data point that needs to be removed from the existing data source.
  • The optional second parameter specifies the animation duration for removing the data point.
<template>
  <div id="app">
    <ejs-chart ref="chart" id="container" :primaryXAxis='primaryXAxis' :primaryYAxis='primaryYAxis' :title='title' :legendSettings='legendSettings' :chartArea='chartArea'>
        <e-series-collection>
          <e-series :dataSource='seriesData' type='Spline' xName='x' yName='y' name='Users' width=2 :marker='marker'></e-series>
        </e-series-collection>
    </ejs-chart>
    <ejs-button id='add' @click.native='onClick'>Add Point</ejs-button>
  </div>
</template>
<script setup>
import { provide, ref } from "vue";
import { ChartComponent as EjsChart, SeriesCollectionDirective as ESeriesCollection, SeriesDirective as ESeries, SplineSeries, Category, DataLabel, Legend } from "@syncfusion/ej2-vue-charts";
import { ButtonComponent as EjsButton } from "@syncfusion/ej2-vue-buttons";

const chart = ref(null);
const seriesData = [
  { x: "Germany", y: 72 },
  { x: "Russia", y: 103.1 },
  { x: "Brazil", y: 139.1 },
  { x: "India", y: 462.1 },
  { x: "China", y: 721.4 },
  { x: "USA", y: 286.9 },
  { x: "Great Britain", y: 115.1 },
  { x: "Nigeria", y: 97.2 }
];
const primaryXAxis = {
  valueType: 'Category', 
  enableTrim: false, 
  majorTickLines: { width: 0 }, 
  majorGridLines: { width: 0 }
};
const primaryYAxis = {
  minimum: 0, 
  maximum: 800, 
  labelFormat: '{value}M', 
  edgeLabelPlacement: 'Shift'
};
const marker = {
  visible: true, 
  dataLabel: { 
    visible: true, 
    position: 'Top', 
    font: { 
      fontWeight: '600' 
    } 
  }
};
const title = 'Internet Users - 2016';
const legendSettings = {
  visible: false
};
const chartArea = {
  border: {
    width: 1
  }
};

provide('chart', [SplineSeries, Category, DataLabel, Legend]);

const onClick = function() {     
  this.$refs.chart.ej2Instances.series[0].removePoint(0);
};

</script>
<style>
  #container {
    height: 350px;
  }
</style>
<template>
    <div id="app">
        <ejs-chart ref="chart" id="container" :primaryXAxis='primaryXAxis' :primaryYAxis='primaryYAxis' :title='title' :legendSettings='legendSettings' :chartArea='chartArea'>
          <e-series-collection>
            <e-series :dataSource='seriesData' type='Spline' xName='x' yName='y' name='Users' width=2 :marker='marker'></e-series>
          </e-series-collection>
        </ejs-chart>
        <ejs-button id='remove' @click.native='onClick'>Remove Point</ejs-button>
    </div>
</template>
<script>
import Vue from "vue";
import { ChartPlugin, SplineSeries, Category, DataLabel, Legend } from "@syncfusion/ej2-vue-charts";
import { ButtonPlugin } from "@syncfusion/ej2-vue-buttons";

Vue.use(ChartPlugin);
Vue.use(ButtonPlugin);

export default {
  data() {
    return {
        seriesData: [
          { x: "Germany", y: 72 },
          { x: "Russia", y: 103.1 },
          { x: "Brazil", y: 139.1 },
          { x: "India", y: 462.1 },
          { x: "China", y: 721.4 },
          { x: "USA", y: 286.9 },
          { x: "Great Britain", y: 115.1 },
          { x: "Nigeria", y: 97.2 }
        ],
        primaryXAxis: {
          valueType: 'Category', 
          enableTrim: false, 
          majorTickLines: { width: 0 }, 
          majorGridLines: { width: 0 }
        },
        primaryYAxis:
        {
          minimum: 0, 
          maximum: 800, 
          labelFormat: '{value}M', 
          edgeLabelPlacement: 'Shift'
        },
        marker: {
          visible: true, 
          dataLabel: { 
            visible: true, 
            position: 'Top', 
            font: { 
              fontWeight: '600' 
            } 
          }
        },
        title: 'Internet Users - 2016',
        legendSettings: {
          visible: false
        },
        chartArea: {
          border: {
            width: 1
          }
        }
    };
  },
  provide: {
    chart: [SplineSeries, Category, DataLabel, Legend]
  },
  methods: {
      onClick: function() {     
        this.$refs.chart.ej2Instances.series[0].removePoint(0);
      }
  }
};
</script>
<style>
  #container {
    height: 350px;
  }
</style>

Replacing entire data points

To replace the existing data source in the chart with a new data source, you can simply use the setData method. This method allows you to replace the existing data points in the chart series with a new set of data points, enabling you to easily update the chart with new information. This method takes two parameters:

  • The first parameter is the new set of data points to be updated.
  • The optional second parameter specifies the animation duration for updating the new data source.
<template>
  <div id="app">
    <ejs-chart ref="chart" id="container" :primaryXAxis='primaryXAxis' :primaryYAxis='primaryYAxis' :title='title' :chartArea='chartArea' :axisRangeCalculated='axisRangeCalculated'>
        <e-series-collection>
            <e-series :dataSource='seriesData' type='Column' xName='x' yName='y' columnWidth=0.5 :cornerRadius='cornerRadius'></e-series>
        </e-series-collection>
    </ejs-chart>
    <ejs-button id='update' @click.native='onClick'>Update Data</ejs-button>
  </div>
</template>
<script setup>
import { provide, ref } from "vue";
import { ChartComponent as EjsChart, SeriesCollectionDirective as ESeriesCollection, SeriesDirective as ESeries, ColumnSeries, Category } from "@syncfusion/ej2-vue-charts";
import { ButtonComponent as EjsButton } from "@syncfusion/ej2-vue-buttons";

const chart = ref(null);
const seriesData = [
  { x: 'Jewellery', y: 75 },
  { x: 'Shoes', y: 45 },
  { x: 'Footwear', y: 73 },
  { x: 'Pet Services', y: 53 },
  { x: 'Business Clothing', y: 85 },
  { x: 'Office Supplies', y: 68 },
  { x: 'Food', y: 45 }
];
const primaryXAxis = {
  valueType: 'Category', 
  majorGridLines: { width: 0 }, 
  labelStyle: { size: '12px' }, 
  labelIntersectAction: 'Rotate90'
};
const primaryYAxis = {
  title: 'Sales (in percentage)', 
  labelFormat: '{value}%', 
  lineStyle: { width: 0 }, 
  majorTickLines: { width: 0 }, 
  interval: 5, 
  minimum: 0, 
  maximum: 100
};
const cornerRadius = { 
  topLeft: 15, 
  topRight: 15 
};
const title = 'Sales by product';
const chartArea = {
  border: {
    width: 0
  }
};

provide('chart', [ColumnSeries, Category]);

const getRandomInt = function(min, max) {
  return Math.floor(Math.random() * (max - min + 1)) + min;
};

const axisRangeCalculated = function(args) {
  if (args.axis.name === 'primaryYAxis') {
      args.maximum = args.maximum > 100 ? 100 : args.maximum;
      if (args.maximum > 80) {
          args.interval = 20;
      }
      else if (args.maximum > 40) {
          args.interval = 10;
      }
  }
};
      
const onClick = function() {     
  var newData = this.$refs.chart.ej2Instances.series[0].dataSource.map((item) => {
      var value = getRandomInt(10, 90);
      return { x: item.x, y: value };
  });
  if (this.$refs.chart.ej2Instances.series[0]) {
      this.$refs.chart.ej2Instances.series[0].setData(newData, 500);
  }
};

</script>
<style>
  #container {
    height: 350px;
  }
</style>
<template>
    <div id="app">
        <ejs-chart ref="chart" id="container" :primaryXAxis='primaryXAxis' :primaryYAxis='primaryYAxis' :title='title' :chartArea='chartArea' :axisRangeCalculated='axisRangeCalculated'>
          <e-series-collection>
            <e-series :dataSource='seriesData' type='Column' xName='x' yName='y' columnWidth=0.5 :cornerRadius='cornerRadius'></e-series>
          </e-series-collection>
        </ejs-chart>
        <ejs-button id='update' @click.native='onClick'>Update Data</ejs-button>
    </div>
</template>
<script>
import Vue from "vue";
import { ChartPlugin, ColumnSeries, Category } from "@syncfusion/ej2-vue-charts";
import { ButtonPlugin } from "@syncfusion/ej2-vue-buttons";

Vue.use(ChartPlugin);
Vue.use(ButtonPlugin);

function getRandomInt(min, max) {
    return Math.floor(Math.random() * (max - min + 1)) + min;
}

export default {
  data() {
    return {
        seriesData: [
          { x: 'Jewellery', y: 75 },
          { x: 'Shoes', y: 45 },
          { x: 'Footwear', y: 73 },
          { x: 'Pet Services', y: 53 },
          { x: 'Business Clothing', y: 85 },
          { x: 'Office Supplies', y: 68 },
          { x: 'Food', y: 45 }
        ],
        primaryXAxis: {
          valueType: 'Category', 
          majorGridLines: { width: 0 }, 
          labelStyle: { size: '12px' }, 
          labelIntersectAction: 'Rotate90'
        },
        primaryYAxis:
        {
          title: 'Sales (in percentage)', 
          labelFormat: '{value}%', 
          lineStyle: { width: 0 }, 
          majorTickLines: { width: 0 }, 
          interval: 5, 
          minimum: 0, 
          maximum: 100
        },
        cornerRadius: { 
          topLeft: 15, 
          topRight: 15 
        },
        title: 'Sales by product',
        chartArea: {
          border: {
            width: 0
          }
        }
    };
  },
  provide: {
    chart: [ColumnSeries, Category]
  },
  methods: {
      axisRangeCalculated: function(args) {
          if (args.axis.name === 'primaryYAxis') {
              args.maximum = args.maximum > 100 ? 100 : args.maximum;
              if (args.maximum > 80) {
                args.interval = 20;
              }
              else if (args.maximum > 40) {
                args.interval = 10;
              }
          }
      },
      onClick: function() {     
          var newData = this.$refs.chart.ej2Instances.series[0].dataSource.map((item) => {
            var value = getRandomInt(10, 90);
            return { x: item.x, y: value };
          });
          if (this.$refs.chart.ej2Instances.series[0]) {
              this.$refs.chart.ej2Instances.series[0].setData(newData, 500);
          }
      }
  }
};
</script>
<style>
  #container {
    height: 350px;
  }
</style>

Click to add or remove a data point

You can use mouse or touch events to dynamically add or remove data points from an existing data source by clicking on the appropriate position within the chart area. To add a new data point to the existing data source, click anywhere in the chart area, retrieve the x-axis and y-axis information of the clicked location from the chartMouseClick event arguments. Then, utilize the addPoint method to add a new data point to the existing data source.

To remove a data point from the existing data source, simply click on the desired data point. To achieve this, first, verify whether the clicked data point obtained from chartMouseClick already exists in the data source. If it does, remove it by utilizing the removePoint method based on its index.

<template>
  <div id="app">
    <ejs-chart ref="chart" id="container" :primaryXAxis='primaryXAxis' :primaryYAxis='primaryYAxis' :title='title' :chartArea='chartArea' :axisRangeCalculated='axisRangeCalculated' :chartMouseClick='chartMouseClick'>
        <e-series-collection>
          <e-series :dataSource='seriesData' type='Line' xName='x' yName='y' width=3 :marker='marker'></e-series>
        </e-series-collection>
    </ejs-chart>
  </div>
</template>
<script setup>
import { provide, ref } from "vue";
import { ChartComponent as EjsChart, SeriesCollectionDirective as ESeriesCollection, SeriesDirective as ESeries, LineSeries, DataLabel, Tooltip } from "@syncfusion/ej2-vue-charts";

const chart = ref(null);
const seriesData = [
  { x: 20, y: 20 }, 
  { x: 80, y: 80 }
];
const primaryXAxis = {
  edgeLabelPlacement: 'Shift', 
  rangePadding: 'Additional', 
  majorGridLines: { width: 0 }
};
const primaryYAxis = {
  title: 'Value', 
  interval: 20, 
  lineStyle: { width: 0 }, 
  majorTickLines: { width: 0 }
};
const marker = {
  visible: true, 
  isFilled: true, 
  border: { 
    width: 2, 
    color: 'White' 
  }, 
  width: 13, 
  height: 13 
};
const title = 'User supplied data';
const chartArea = {
  border: {
    width: 0
  }
};

provide('chart', [LineSeries, DataLabel, Tooltip]);

const chartMouseClick = function(args) {
  let isRemoved = false;
  if (args.axisData) {
      for (let i = 0; i < this.$refs.chart.ej2Instances.series[0].points.length; i++) {
            let markerWidth = this.$refs.chart.ej2Instances.series[0].marker.width / 2;
            let roundedX = Math.round(args.axisData['primaryXAxis']) + markerWidth;
            let roundedY = Math.round(args.axisData['primaryYAxis']) + markerWidth;
            let pointX = Math.round(this.$refs.chart.ej2Instances.series[0].points[i].x) + markerWidth;
            let pointY = Math.round(this.$refs.chart.ej2Instances.series[0].points[i].y) + markerWidth;
            if ((roundedX === pointX || roundedX + 1 === pointX || roundedX - 1 === pointX) &&
                (roundedY === pointY || roundedY + 1 === pointY || roundedY - 1 === pointY)) {
                if (this.$refs.chart.ej2Instances.series[0].points.length > 1) {
                    const points = this.$refs.chart.ej2Instances.series[0].points;
                    const duration = i === 0 || i === points[points.length - 1].index ? 500 : 0;
                    this.$refs.chart.ej2Instances.series[0].removePoint(i, duration);
                }
                isRemoved = true;
            }
      }
      if (!isRemoved) {
          this.$refs.chart.ej2Instances.series[0].addPoint({ x: Math.round(args.axisData['primaryXAxis']), y: Math.round(args.axisData['primaryYAxis']) });
      }
  }
};
      
const axisRangeCalculated = function(args) {
  if (args.axis.name === 'primaryXAxis') {
      if (args.interval < 10) {
          args.maximum = args.maximum + 10;
          args.minimum = args.minimum - 10;
          args.interval = 10;
      }
  }
  if (args.axis.name === 'primaryYAxis') {
      if (args.maximum <= 60) {
          args.interval = 10;
      }
  }
};

</script>
<style>
  #container {
    height: 350px;
  }
</style>
<template>
    <div id="app">
        <ejs-chart ref="chart" id="container" :primaryXAxis='primaryXAxis' :primaryYAxis='primaryYAxis' :title='title' :chartArea='chartArea' :axisRangeCalculated='axisRangeCalculated' :chartMouseClick='chartMouseClick'>
          <e-series-collection>
            <e-series :dataSource='seriesData' type='Line' xName='x' yName='y' width=3 :marker='marker'></e-series>
          </e-series-collection>
        </ejs-chart>
    </div>
</template>
<script>
import Vue from "vue";
import { ChartPlugin, LineSeries, DataLabel, Tooltip } from "@syncfusion/ej2-vue-charts";

Vue.use(ChartPlugin);

export default {
  data() {
    return {
        seriesData: [
          { x: 20, y: 20 }, 
          { x: 80, y: 80 }
        ],
        primaryXAxis: {
          edgeLabelPlacement: 'Shift', 
          rangePadding: 'Additional', 
          majorGridLines: { width: 0 }
        },
        primaryYAxis:
        {
          title: 'Value', 
          interval: 20, 
          lineStyle: { width: 0 }, 
          majorTickLines: { width: 0 }
        },
        marker: { 
          visible: true, 
          isFilled: true, 
          border: { 
            width: 2, 
            color: 'White' 
          }, 
          width: 13, 
          height: 13 
        },
        title: 'User supplied data',
        chartArea: {
          border: {
            width: 0
          }
        }
    };
  },
  provide: {
    chart: [LineSeries, DataLabel, Tooltip]
  },
  methods: {
      chartMouseClick: function(args) {
        let isRemoved = false;
        if (args.axisData) {
            for (let i = 0; i < this.$refs.chart.ej2Instances.series[0].points.length; i++) {
                let markerWidth = this.$refs.chart.ej2Instances.series[0].marker.width / 2;
                let roundedX = Math.round(args.axisData['primaryXAxis']) + markerWidth;
                let roundedY = Math.round(args.axisData['primaryYAxis']) + markerWidth;
                let pointX = Math.round(this.$refs.chart.ej2Instances.series[0].points[i].x) + markerWidth;
                let pointY = Math.round(this.$refs.chart.ej2Instances.series[0].points[i].y) + markerWidth;
                if ((roundedX === pointX || roundedX + 1 === pointX || roundedX - 1 === pointX) &&
                    (roundedY === pointY || roundedY + 1 === pointY || roundedY - 1 === pointY)) {
                    if (this.$refs.chart.ej2Instances.series[0].points.length > 1) {
                        const points = this.$refs.chart.ej2Instances.series[0].points;
                        const duration = i === 0 || i === points[points.length - 1].index ? 500 : 0;
                        this.$refs.chart.ej2Instances.series[0].removePoint(i, duration);
                    }
                    isRemoved = true;
                }
            }
            if (!isRemoved) {
                    this.$refs.chart.ej2Instances.series[0].addPoint({ x: Math.round(args.axisData['primaryXAxis']), y: Math.round(args.axisData['primaryYAxis']) });
            }
        }
      },
      axisRangeCalculated: function(args) {
        if (args.axis.name === 'primaryXAxis') {
            if (args.interval < 10) {
                args.maximum = args.maximum + 10;
                args.minimum = args.minimum - 10;
                args.interval = 10;
            }
        }
        if (args.axis.name === 'primaryYAxis') {
            if (args.maximum <= 60) {
                args.interval = 10;
            }
        }
      }
  }
};
</script>
<style>
  #container {
    height: 350px;
  }
</style>

Syncfusion AI Assistant

How can I help you?

Dynamic data update in React Chart component

24 Feb 202624 minutes to read

The React Chart component provides methods to dynamically modify data without requiring a full chart refresh. This enables real-time data visualization, interactive features, and responsive user experiences. Common scenarios include adding sensor readings, removing outdated data points, replacing entire datasets, and enabling click-based data manipulation.

Adding a new data point

Use the addPoint method to dynamically append a new data point to a series. This is useful for real-time data streams, user interactions, or incremental data loading. The method accepts the following parameters:

  • Data point (required): The new data object to append to the series (must match the datasource structure)
  • Animation duration (optional): Duration in milliseconds for the entry animation
import * as React from "react";
import * as ReactDOM from "react-dom";
import {
  ChartComponent, SeriesCollectionDirective, SeriesDirective, Inject,
  Legend, Category, DataLabel, SplineSeries
} from '@syncfusion/ej2-react-charts';
import { data } from './datasource';

function App() {
  const primaryXAxis = { valueType: 'Category', enableTrim: false, majorTickLines: { width: 0 }, majorGridLines: { width: 0 } };
  const primaryYAxis = { minimum: 0, maximum: 800, labelFormat: '{value}M', edgeLabelPlacement: 'Shift' };
  const marker = {
    visible: true,
    dataLabel: {
      visible: true,
      position: 'Top',
      font: {
        fontWeight: '600'
      }
    }
  };
  const legendSettings = { visible: false };
  let chartInstance;
  function clickHandler() {
    chartInstance.series[0].addPoint({ x: 'Japan', y: 118.2 });
  }
  return (<div>
    <button value='add' onClick={clickHandler.bind(this)}>Add Point</button>
    <ChartComponent id='charts' ref={chart => chartInstance = chart} primaryXAxis={primaryXAxis} primaryYAxis={primaryYAxis} legendSettings={legendSettings} title='Internet Users - 2016' chartArea={{ border: { width: 1 } }}>
      <Inject services={[SplineSeries, Legend, DataLabel, Category]} />
      <SeriesCollectionDirective>
        <SeriesDirective dataSource={data} xName='x' yName='y' width={2} name='Users' type='Spline' marker={marker}>
        </SeriesDirective>
      </SeriesCollectionDirective>
    </ChartComponent></div>);
}
;
export default App;
ReactDOM.render(<App />, document.getElementById("charts"));
import * as React from "react";
import * as ReactDOM from "react-dom";
import {
  AxisModel, ChartComponent, SeriesCollectionDirective, SeriesDirective, Inject,
  Legend, Category, DataLabel, SplineSeries, MarkerSettingsModel, LegendSettingsModel
} from '@syncfusion/ej2-react-charts';
import { data } from './datasource';

function App() {
  const primaryXAxis: AxisModel = { valueType: 'Category', enableTrim: false, majorTickLines: { width: 0 }, majorGridLines: { width: 0 } };
  const primaryYAxis: AxisModel = { minimum: 0, maximum: 800, labelFormat: '{value}M', edgeLabelPlacement: 'Shift' };
  const marker: MarkerSettingsModel = {
    visible: true,
    dataLabel: {
      visible: true,
      position: 'Top',
      font: {
        fontWeight: '600'
      }
    }
  };
  const legendSettings: LegendSettingsModel = { visible: false };
  let chartInstance: ChartComponent;
  function clickHandler() {
    chartInstance.series[0].addPoint({ x: 'Japan', y: 118.2 });
  }

  return (<div>
    <button value='add' onClick={clickHandler.bind(this)}>Add Point</button>
    <ChartComponent id='charts' ref={chart => chartInstance = chart} primaryXAxis={primaryXAxis} primaryYAxis={primaryYAxis} legendSettings={legendSettings} title='Internet Users - 2016' chartArea={{ border: { width: 1 } }}>
      <Inject services={[SplineSeries, Legend, DataLabel, Category]} />
      <SeriesCollectionDirective>
        <SeriesDirective dataSource={data} xName='x' yName='y' width={2} name='Users' type='Spline' marker={marker}>
        </SeriesDirective>
      </SeriesCollectionDirective>
    </ChartComponent></div>)
};
export default App;
ReactDOM.render(<App />, document.getElementById("charts"));
export let data = [
    { x: "Germany",       y: 72 },
    { x: "Russia",        y: 103.1 },
    { x: "Brazil",        y: 139.1 },
    { x: "India",         y: 462.1 },
    { x: "China",         y: 721.4 },
    { x: "USA",           y: 286.9 },
    { x: "Great Britain", y: 115.1 },
    { x: "Nigeria",       y: 97.2 }
];
export let data: Object[] = [
    { x: "Germany",       y: 72 },
    { x: "Russia",        y: 103.1 },
    { x: "Brazil",        y: 139.1 },
    { x: "India",         y: 462.1 },
    { x: "China",         y: 721.4 },
    { x: "USA",           y: 286.9 },
    { x: "Great Britain", y: 115.1 },
    { x: "Nigeria",       y: 97.2 }
];

Removing an existing data point

Use the removePoint method to dynamically delete a data point from a series by its index. This is useful for filtering data, removing outliers, or responding to user actions. The method accepts the following parameters:

  • Point index (required): The zero-based index of the data point to remove
  • Animation duration (optional): Duration in milliseconds for the exit animation
import * as React from "react";
import * as ReactDOM from "react-dom";
import {
  ChartComponent, SeriesCollectionDirective, SeriesDirective, Inject,
  Legend, Category, DataLabel, SplineSeries
} from '@syncfusion/ej2-react-charts';
import { data } from './datasource';

function App() {
  const primaryXAxis = { valueType: 'Category', enableTrim: false, majorTickLines: { width: 0 }, majorGridLines: { width: 0 } };
  const primaryYAxis = { minimum: 0, maximum: 800, labelFormat: '{value}M', edgeLabelPlacement: 'Shift' };
  const marker = {
    visible: true,
    dataLabel: {
      visible: true,
      position: 'Top',
      font: {
        fontWeight: '600'
      }
    }
  };
  const legendSettings = { visible: false };
  let chartInstance;
  function clickHandler() {
    chartInstance.series[0].removePoint(0);
  }
  return (<div>
    <button value='remove' onClick={clickHandler.bind(this)}>Remove Point</button>
    <ChartComponent id='charts' ref={chart => chartInstance = chart} primaryXAxis={primaryXAxis} primaryYAxis={primaryYAxis} legendSettings={legendSettings} title='Internet Users - 2016' chartArea={{ border: { width: 1 } }}>
      <Inject services={[SplineSeries, Legend, DataLabel, Category]} />
      <SeriesCollectionDirective>
        <SeriesDirective dataSource={data} xName='x' yName='y' width={2} name='Users' type='Spline' marker={marker}>
        </SeriesDirective>
      </SeriesCollectionDirective>
    </ChartComponent></div>);
}
;
export default App;
ReactDOM.render(<App />, document.getElementById("charts"));
import * as React from "react";
import * as ReactDOM from "react-dom";
import {
  AxisModel, ChartComponent, SeriesCollectionDirective, SeriesDirective, Inject,
  Legend, Category, DataLabel, SplineSeries, MarkerSettingsModel, LegendSettingsModel
} from '@syncfusion/ej2-react-charts';
import { data } from './datasource';

function App() {
  const primaryXAxis: AxisModel = { valueType: 'Category', enableTrim: false, majorTickLines: { width: 0 }, majorGridLines: { width: 0 } };
  const primaryYAxis: AxisModel = { minimum: 0, maximum: 800, labelFormat: '{value}M', edgeLabelPlacement: 'Shift' };
  const marker: MarkerSettingsModel = {
    visible: true,
    dataLabel: {
      visible: true,
      position: 'Top',
      font: {
        fontWeight: '600'
      }
    }
  };
  const legendSettings: LegendSettingsModel = { visible: false };
  let chartInstance: ChartComponent;
  function clickHandler() {
    chartInstance.series[0].removePoint(0);
  }

  return (<div>
    <button value='remove' onClick={clickHandler.bind(this)}>Remove Point</button>
    <ChartComponent id='charts' ref={chart => chartInstance = chart} primaryXAxis={primaryXAxis} primaryYAxis={primaryYAxis} legendSettings={legendSettings} title='Internet Users - 2016' chartArea={{ border: { width: 1 } }}>
      <Inject services={[SplineSeries, Legend, DataLabel, Category]} />
      <SeriesCollectionDirective>
        <SeriesDirective dataSource={data} xName='x' yName='y' width={2} name='Users' type='Spline' marker={marker}>
        </SeriesDirective>
      </SeriesCollectionDirective>
    </ChartComponent></div>)
};
export default App;
ReactDOM.render(<App />, document.getElementById("charts"));
export let data = [
    { x: "Germany",       y: 72 },
    { x: "Russia",        y: 103.1 },
    { x: "Brazil",        y: 139.1 },
    { x: "India",         y: 462.1 },
    { x: "China",         y: 721.4 },
    { x: "USA",           y: 286.9 },
    { x: "Great Britain", y: 115.1 },
    { x: "Nigeria",       y: 97.2 }
];
export let data: Object[] = [
    { x: "Germany",       y: 72 },
    { x: "Russia",        y: 103.1 },
    { x: "Brazil",        y: 139.1 },
    { x: "India",         y: 462.1 },
    { x: "China",         y: 721.4 },
    { x: "USA",           y: 286.9 },
    { x: "Great Britain", y: 115.1 },
    { x: "Nigeria",       y: 97.2 }
];

Replacing entire data points

Use the setData method to replace all data points in a series with a new dataset. This is useful for category switching, time range changes, or complete data refreshes. The method accepts the following parameters:

  • New data source (required): The complete new dataset array to display
  • Animation duration (optional): Duration in milliseconds for the transition animation
import * as React from "react";
import * as ReactDOM from "react-dom";
import { ChartComponent, SeriesCollectionDirective, SeriesDirective, Inject, ColumnSeries, Category } from '@syncfusion/ej2-react-charts';
import { data } from './datasource';

function App() {
  const primaryXAxis = { valueType: 'Category', majorGridLines: { width: 0 }, labelStyle: { size: '12px' }, labelIntersectAction: 'Rotate90' };
  const primaryYAxis = { title: 'Sales (in percentage)', labelFormat: '{value}%', lineStyle: { width: 0 }, majorTickLines: { width: 0 }, interval: 5, minimum: 0, maximum: 100 };
  let chartInstance;
  function clickHandler() {
    const newData = data.map((item) => {
      const value = getRandomInt(10, 90);
      return { x: item.x, y: value };
    });
    if (chartInstance.series.length > 0) {
      chartInstance.series[0].setData(newData, 500);
    }
  }

  function getRandomInt(min, max) {
    return Math.floor(Math.random() * (max - min + 1)) + min;
  }

  let axisRangeCalculated = (args) => {
    if (args.axis.name === 'primaryYAxis') {
      args.maximum = args.maximum > 100 ? 100 : args.maximum;
      if (args.maximum > 80) {
        args.interval = 20;
      }
      else if (args.maximum > 40) {
        args.interval = 10;
      }
    }
  }
  return (<div>
    <button value='update' onClick={clickHandler.bind(this)}>Update Data</button>
    <ChartComponent id='charts' ref={chart => chartInstance = chart} primaryXAxis={primaryXAxis} primaryYAxis={primaryYAxis} title='Sales by product' chartArea={{ border: { width: 0 } }} axisRangeCalculated={axisRangeCalculated.bind(this)}>
      <Inject services={[ColumnSeries, Category]} />
      <SeriesCollectionDirective>
        <SeriesDirective dataSource={data} xName='x' yName='y' cornerRadius={{ topLeft: 15, topRight: 15 }} columnWidth={0.5} type='Column'>
        </SeriesDirective>
      </SeriesCollectionDirective>
    </ChartComponent></div>);
}
;
export default App;
ReactDOM.render(<App />, document.getElementById("charts"));
import * as React from "react";
import * as ReactDOM from "react-dom";
import {
  AxisModel, ChartComponent, SeriesCollectionDirective, SeriesDirective, Inject,
  ColumnSeries, Category, IAxisRangeCalculatedEventArgs
} from '@syncfusion/ej2-react-charts';
import { data } from './datasource';

function App() {
  const primaryXAxis: AxisModel = { valueType: 'Category', majorGridLines: { width: 0 }, labelStyle: { size: '12px' }, labelIntersectAction: 'Rotate90' };
  const primaryYAxis: AxisModel = { title: 'Sales (in percentage)', labelFormat: '{value}%', lineStyle: { width: 0 }, majorTickLines: { width: 0 }, interval: 5, minimum: 0, maximum: 100 };
  let chartInstance: ChartComponent;
  function clickHandler() {
    const newData = data.map((item: { x: string, y: number }) => {
      const value: number = getRandomInt(10, 90);
      return { x: item.x, y: value };
    });
    if (chartInstance.series.length > 0) {
      chartInstance.series[0].setData(newData, 500);
    }
  }

  function getRandomInt(min: number, max: number) {
    return Math.floor(Math.random() * (max - min + 1)) + min;
  }

  let axisRangeCalculated = (args: IAxisRangeCalculatedEventArgs): void => {
    if (args.axis.name === 'primaryYAxis') {
      args.maximum = args.maximum as number > 100 ? 100 : args.maximum;
      if (args.maximum > 80) {
        args.interval = 20;
      }
      else if (args.maximum > 40) {
        args.interval = 10;
      }
    }
  }

  return (<div>
    <button value='update' onClick={clickHandler.bind(this)}>Update Data</button>
    <ChartComponent id='charts' ref={chart => chartInstance = chart} primaryXAxis={primaryXAxis} primaryYAxis={primaryYAxis} title='Sales by product' chartArea={{ border: { width: 0 } }} axisRangeCalculated={axisRangeCalculated.bind(this)}>
      <Inject services={[ColumnSeries, Category]} />
      <SeriesCollectionDirective>
        <SeriesDirective dataSource={data} xName='x' yName='y' cornerRadius={{ topLeft: 15, topRight: 15 }} columnWidth={0.5} type='Column'>
        </SeriesDirective>
      </SeriesCollectionDirective>
    </ChartComponent></div>)
};
export default App;
ReactDOM.render(<App />, document.getElementById("charts"));
export let data = [
    { x: 'Jewellery', y: 75 },
    { x: 'Shoes', y: 45 },
    { x: 'Footwear', y: 73 },
    { x: 'Pet Services', y: 53 },
    { x: 'Business Clothing', y: 85 },
    { x: 'Office Supplies', y: 68 },
    { x: 'Food', y: 45 }
];
export let data: any[] = [
    { x: 'Jewellery', y: 75 },
    { x: 'Shoes', y: 45 },
    { x: 'Footwear', y: 73 },
    { x: 'Pet Services', y: 53 },
    { x: 'Business Clothing', y: 85 },
    { x: 'Office Supplies', y: 68 },
    { x: 'Food', y: 45 }
];

Click to add or remove a data point

Enable users to add or remove data points by clicking on the chart. Listen to the chartMouseClick event to capture click coordinates and point information. When a user clicks within the chart area, extract the x and y axis values from the event arguments. If the location is empty, use addPoint to add a new data point at those coordinates. If a user clicks on an existing data point, identify its index and use removePoint to delete it. This creates an intuitive interface for data exploration and editing.

import * as React from "react";
import * as ReactDOM from "react-dom";
import { ChartComponent, SeriesCollectionDirective, SeriesDirective, Inject, LineSeries, DataLabel, Tooltip } from '@syncfusion/ej2-react-charts';
import { data } from './datasource';

function App() {
  const primaryXAxis = { edgeLabelPlacement: 'Shift', rangePadding: 'Additional', majorGridLines: { width: 0 } };
  const primaryYAxis = { title: 'Value', interval: 20, lineStyle: { width: 0 }, majorTickLines: { width: 0 } };
  const marker = {
    visible: true,
    isFilled: true,
    border: {
      width: 2,
      color: 'White'
    },
    width: 13,
    height: 13
  };
  const tooltip = { enable: true };
  let chartInstance;
  const axisRangeCalculated = (args) => {
    if (args.axis.name === 'primaryXAxis') {
      if (args.interval < 10) {
        args.maximum = args.maximum + 10;
        args.minimum = args.minimum - 10;
        args.interval = 10;
      }
    }
    if (args.axis.name === 'primaryYAxis') {
      if (args.maximum <= 60) {
        args.interval = 10;
      }
    }
  }

  const chartMouseClick = (args) => {
    let isRemoved = false;
    if (args.axisData) {
      for (let i = 0; i < (chartInstance.series[0]).points.length; i++) {
        const markerWidth = (chartInstance.series[0]).marker.width / 2;
        let roundedX = Math.round(args.axisData['primaryXAxis']) + markerWidth;
        let roundedY = Math.round(args.axisData['primaryYAxis']) + markerWidth;
        let pointX = Math.round((chartInstance.series[0]).points[i].x) + markerWidth;
        let pointY = Math.round((chartInstance.series[0]).points[i].y) + markerWidth;
        if ((roundedX === pointX || roundedX + 1 === pointX || roundedX - 1 === pointX) &&
          (roundedY === pointY || roundedY + 1 === pointY || roundedY - 1 === pointY)) {
          if ((chartInstance.series[0]).points.length > 1) {
            const points = (chartInstance.series[0]).points;
            const duration = i === 0 || i === points[points.length - 1].index ? 500 : 0;
            chartInstance.series[0].removePoint(i, duration);
          }
          isRemoved = true;
        }
      }
      if (!isRemoved) {
        chartInstance.series[0].addPoint({ x: Math.round(args.axisData['primaryXAxis']), y: Math.round(args.axisData['primaryYAxis']) });
      }
    }
  };
  return (<div>
    <ChartComponent id='charts' ref={chart => chartInstance = chart} primaryXAxis={primaryXAxis} primaryYAxis={primaryYAxis} tooltip={tooltip} title='User supplied data' chartArea={{ border: { width: 0 } }} axisRangeCalculated={axisRangeCalculated.bind(this)} chartMouseClick={chartMouseClick.bind(this)}>
      <Inject services={[LineSeries, DataLabel, Tooltip]} />
      <SeriesCollectionDirective>
        <SeriesDirective dataSource={data} xName='x' yName='y' marker={marker} width={3} type='Line'>
        </SeriesDirective>
      </SeriesCollectionDirective>
    </ChartComponent></div>);
}
;
export default App;
ReactDOM.render(<App />, document.getElementById("charts"));
import * as React from "react";
import * as ReactDOM from "react-dom";
import {
  AxisModel, ChartComponent, SeriesCollectionDirective, SeriesDirective, Inject,
  LineSeries, DataLabel, Tooltip, MarkerSettingsModel, IAxisRangeCalculatedEventArgs, Series, TooltipSettingsModel, IMouseEventArgs
} from '@syncfusion/ej2-react-charts';
import { data } from './datasource';

function App() {
  const primaryXAxis: AxisModel = { edgeLabelPlacement: 'Shift', rangePadding: 'Additional', majorGridLines: { width: 0 } };
  const primaryYAxis: AxisModel = { title: 'Value', interval: 20, lineStyle: { width: 0 }, majorTickLines: { width: 0 } };
  const marker: MarkerSettingsModel = {
    visible: true,
    isFilled: true,
    border: {
      width: 2,
      color: 'White'
    },
    width: 13,
    height: 13
  };
  const tooltip: TooltipSettingsModel = { enable: true };
  let chartInstance: ChartComponent;
  const axisRangeCalculated = (args: IAxisRangeCalculatedEventArgs): void => {
    if (args.axis.name === 'primaryXAxis') {
      if (args.interval < 10) {
        args.maximum = args.maximum + 10;
        args.minimum = args.minimum - 10;
        args.interval = 10;
      }
    }
    if (args.axis.name === 'primaryYAxis') {
      if (args.maximum <= 60) {
        args.interval = 10;
      }
    }
  }

  const chartMouseClick = (args: IMouseEventArgs): void => {
    let isRemoved: boolean = false;
    if (args.axisData) {
      for (let i: number = 0; i < (chartInstance.series[0] as Series).points.length; i++) {
        const markerWidth: number = (chartInstance.series[0] as Series).marker.width / 2;
        let roundedX: number = Math.round(args.axisData['primaryXAxis']) + markerWidth;
        let roundedY: number = Math.round(args.axisData['primaryYAxis']) + markerWidth;
        let pointX: number = Math.round((chartInstance.series[0] as Series).points[i].x as number) + markerWidth;
        let pointY: number = Math.round((chartInstance.series[0] as Series).points[i].y as number) + markerWidth;
        if ((roundedX === pointX || roundedX + 1 === pointX || roundedX - 1 === pointX) &&
          (roundedY === pointY || roundedY + 1 === pointY || roundedY - 1 === pointY)) {
          if ((chartInstance.series[0] as Series).points.length > 1) {
            const points = (chartInstance.series[0] as Series).points;
            const duration: number = i === 0 || i === points[points.length - 1].index ? 500 : 0;
            chartInstance.series[0].removePoint(i, duration);
          }
          isRemoved = true;
        }
      }
      if (!isRemoved) {
        chartInstance.series[0].addPoint({ x: Math.round(args.axisData['primaryXAxis']), y: Math.round(args.axisData['primaryYAxis']) });
      }
    }
  };

  return (<div>
    <ChartComponent id='charts' ref={chart => chartInstance = chart} primaryXAxis={primaryXAxis} primaryYAxis={primaryYAxis} tooltip={tooltip} title='User supplied data' chartArea={{ border: { width: 0 } }} axisRangeCalculated={axisRangeCalculated.bind(this)} chartMouseClick={chartMouseClick.bind(this)}>
      <Inject services={[LineSeries, DataLabel, Tooltip]} />
      <SeriesCollectionDirective>
        <SeriesDirective dataSource={data} xName='x' yName='y' marker={marker} width={3} type='Line'>
        </SeriesDirective>
      </SeriesCollectionDirective>
    </ChartComponent></div>)
};
export default App;
ReactDOM.render(<App />, document.getElementById("charts"));
export let data = [
    { x: 20, y: 20 },
    { x: 80, y: 80 }
];
export let data: Object[] = [
    { x: 20, y: 20 },
    { x: 80, y: 80 }
];